! gfortran -g -Wall a14v1.f90 -o a14v1.exe
! a14v1.exe < a14v1.f90 | more



program a14v1
! https://de.wikibooks.org/wiki/Fortran:_Fortran_95:_Standardfunktionen:_Stringfunktionen
    implicit none
    character*(132) :: line
    character*(13) :: delimiter=" ,()""=:!/.*+-"
    character*(52) :: letter="abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"
    character*(10) :: digit="0123456789"
    integer :: ios, posdel
    
    do
        read(*,"(a)",iostat=ios) line
        if ( ios /= 0 ) exit
        line = adjustl ( line )
        write (*,"(a6,i4,a,a)") "======", len_trim(line), " chars: ", trim(line)
        
        parse: do
            posdel = scan ( line, delimiter ) ! position of first delimiter
            if ( posdel .gt. 1 ) then
                if ( verify(line(1:posdel-1),letter) .eq. 0 ) then
                    print *, "word:  ", line(1:posdel-1)
                else if ( verify(line(1:posdel-1),digit) .eq. 0  ) then
                    print *, "number:", line(1:posdel-1)
                else
                    print *, "mix:   ", "/",line(1:posdel-1),"/", &
                    & verify(line(1:posdel-1),letter), " first non letter char in string", &
                    & verify(line(1:posdel-1),digit), "  first non digit char in string" 
                end if
            end if
            line = line(posdel+1:)
            if ( trim(line) .eq. "" ) exit parse
        end do parse
    
    end do
    
end program
