!gfortran -g -Wall a14v2.f90 -o a14v2.exe
!a14v2.exe < a14v2.f90 | more

program a14v1
! https://de.wikibooks.org/wiki/Fortran:_Fortran_95:_Standardfunktionen:_Stringfunktionen
    implicit none
    character*(132) :: line
    integer :: ios, i, n, len_token
    logical :: isword, isnumber
    
    do
        read(*,"(a)",iostat=ios) line
        if ( ios /= 0 ) exit
        line = adjustl ( line )
        write (*,"(a5,i4,a,a)") "=====", len_trim(line), " chars: ", trim(line)
        
        do
            if ( len_trim(line) .le. 0 ) exit ! only blanks left
            n = len_token ( trim(line) )
            if ( n .gt. 0 ) then ! found next token
                write (*,"(a1,a,a1)", advance="no") "/", line (1:n), "/"
                if ( isword ( line(1:n) ) ) then
                    write (*,*) " - Wort"
                else if ( isnumber ( line(1:n) ) ) then
                    write (*,*) " - Zahl"
                else
                    write (*,*) " - Mix"
                end if
            end if
            if ( n+2 <= len_trim(line) ) then
                line = line(n+2:len_trim(line))
                cycle
            else
                exit
            end if
        end do
    
    end do
    
end program

logical function isword ( string )
    implicit none
    character*(*) :: string
    logical :: isletter
    integer :: i
    
    isword = .true.
    do i = 1, len(string)
        if ( .not. isletter ( string(i:i) ) ) then
            isword = .false.
            return
        end if
    end do
    return
end function

logical function isnumber ( string )
    implicit none
    character*(*) :: string
    logical :: isdigit
    integer :: i
    
    isnumber = .true.
    do i = 1, len(string)
        if ( .not. isdigit ( string(i:i) ) ) then
            isnumber = .false.
            return
        end if
    end do
    return
end function

integer function len_token ( string )
    implicit none
    character*(*) :: string
    logical :: isdelimiter
    integer :: i
    
    len_token = len(string)
    do i = 1, len(string)
        if ( isdelimiter ( string(i:i) ) ) then
            len_token = i-1
            return
        end if
    end do
    return
end function

logical function isdelimiter ( char )
    implicit none
    character*(*), parameter :: delimiter=" ,()""=:!/.*+-"
    character :: char
    integer :: i
    
    isdelimiter = .false.
    do i = 1, len(delimiter)
        if ( char .eq. delimiter(i:i) ) then
            isdelimiter = .true.
            return
        end if
    end do
    return
end function

logical function isdigit ( char )
    implicit none
    character :: char
    
    if ( lge(char, "0") .and. lle(char, "9") ) then
        isdigit = .true.
    else
        isdigit = .false.
    end if
    return
end function

logical function isletter ( char )
    implicit none
    character :: char
    
    if ( lge(char, "a") .and. lle(char, "z") .or. lge(char, "A") .and. lle(char, "Z")) then
        isletter = .true.
    else
        isletter = .false.
    end if
    return
end function
